#ifndef __CONFIGS_H__
#define __CONFIGS_H__

#include "config_struct.h"
#include "daem.h"

extern struct Config *cfgptr;

enum state{
    RUNNING=1,
    EXITED=2,
    ENABLE=4,
    RESTARTRECOMEND=8,
    RESTARTREQUIRED=16
};

enum configflags{
    ISCOMPLETE=1,
    RESTART_ON_CRASH=2,
    RESTART_ON_EXIT=4
};

int setValueDaemon(char* property, char* value, void * d);

struct Daemon readDaemonCfg(const char *path, int *err);

struct Config readSelfCfg(const char *path, int *err);

// merge a daemon, by taking the configured values and leaving the runtime values in place
struct Daemon mergeDaemonToRunning(struct Daemon running, struct Daemon free);

// merge a daemon, by taking the runtime values and leaving the configured values
struct Daemon mergeDaemonToFree(struct Daemon free, struct Daemon running);

// check if restarting a daemon after merging would be recomended or required
// recomended when name exec or argv change (only debugging tools would have minor issues with this)
// required when logf or errf change (reading the logf or errf files would result in errors if they changed without the running process knowing)
// return 0 when nothing is recomended, return RESTARTRECOMEND when recomended, return RESTARTREQUIRED when required
int shouldRestartDaemon(struct Daemon a, struct Daemon b);

#endif