#ifndef __NETPROTO_H__
#define __NETPROTO_H__

#ifndef API_VERSION
#define API_VERSION 1
#endif

enum msgtype{
    // dat is string with service name
    STARTSERVICE,
    // dat is string with service name
    STOPSERVICE,
    // dat is string with service name
    KILLSERVICE,
    // dat is string with service name
    RESTARTSERVICE,
    // dat is string with service name
    ENABLESERVICE,
    // dat is string with service name
    DISABLESERVICE,
    // dat is string with service name
    // returns null terminated list of info about the server
    // order is name, exec, argv, logf, errf, state, pid, exitstatus, and exitreason
    STATUS,

    // dat is null seperated list of variables (eg "VAR=B\0AES=YES")
    SETENV,
    // dat is null seperated list of variables (eg "VAR=B\0AES=YES")
    MERGEENV,
    // dat is null seperated list of evarnames
    UNSETENV,

    //none
    RELOADDAEMON,

    MAXMSGTYPE
};

struct header {
    unsigned int version;
    enum msgtype type;
    unsigned long datalength;
};

enum errortype{
    OK,
    NOSUCHSERVICE,
    NOTIMPLEMENTED,
    MOREDATA, // send another header with information requested
    SERVICEINCOMPLETE, // service fields aren't fully filled out
    SERVICERUNNING, // service is allready running

    MAXERRTYPE
};

struct Status{
    unsigned int version;
    enum errortype err;
};

#endif